.data
#cas
strRDR: .asciiz "\nRDR : "
RCR: .word 0xffff0000
RDR: .word 0xffff0004

#usefull
lineBreak: .asciiz "\n"
end: .asciiz "End of print\n"

.text


#->>---------------------------------------------
#MAIN
_main_:
	li $a0, 1
	li $a1, 100
for: ble $a0, $a1, _check_input_
	j _stop_ 			# SINON
#-<<---------------------------------------------


#->>---------------------------------------------
_check_input_:
#prologue
	sub $sp, $sp, 4
	sw $ra, ($sp)
#corps
	##->>>------------
	#premiere recuperation avant la condition
	lw $t1, RCR
	lw $t1, ($t1)			#recuperation de la valeur dans RCR
	##-<<<------------
	li $v0, 0			#remise a zero de $v0 a cause de `syscall`
check:	##->>>------------
	#deuxieme recuperation dans la condition
	lw $t1, RCR
	lw $t1, ($t1)			#recuperation de la valeur dans RCR
	##-<<<------------
	beqz $t1, next			#teste si la valeur de RDR a deja ete lue
	lw $t0, RDR
	lw $t0, ($t0)			#recuperation de la valeur dans RDR
	move $a0, $s0			#passage en argument de l'element à incrementation ou decrementation
	beq $t0, 120, _stop_		#si on tape sur `x`, arret du programme
	beq $t0, 111, _increase_	#si on tape sur `o`, incrementation de $s0
	beq $t0, 112, _decrease_	#si on tape sur `p`, decrementation de $s0
next:	sub $a1, $a1, 1			#compteur decrementé de 1
	move $s0, $v0			#recuperation de la valeur modifier
	
	jal _sleep_			#mis en pause du processus
	jal _print_regClavier_		#affichage de registre de donnée RDR
	
	move $a0, $s0			#affichage de la valeur de $s0
	li $v0, 1
	syscall
#epilogue
	lw $ra, ($sp)
	add $sp, $sp, 4
#return
	j for
#-<<---------------------------------------------


#->>---------------------------------------------
_increase_:
##	Augement la valeur de l'argument $a0 de 1
##ARGS: $a0<entier>
##RETU: $v0<entier>
##PREC: NONE
#prologue
	sub $sp, $sp, 4
	sw $ra,($sp)
#corps
	addi $v0, $a0, 1
#epilogue
	lw $ra, ($sp)
	add $sp, $sp, 4
	
	j check 				#retoure a la ligne qui teste si il faut faire une lecture
#-<<---------------------------------------------


#->>---------------------------------------------
_decrease_:
##	Diminution la valeur de l'argument $a0 de 1
##ARGS: $a0<entier>
##RETU: $v0<entier>
##PREC: NONE
#prologue
	sub $sp, $sp, 4
	sw $ra,($sp)
#corps
	sub $v0, $a0, 1
#epilogue
	lw $ra, ($sp)
	add $sp, $sp, 4
	
	j check 				#retoure a la ligne qui teste si il faut faire une lecture
#-<<---------------------------------------------


#->>---------------------------------------------
_print_regClavier_:
##	Affiche le registre de donnée
##ARGS: VOID
##RETU: VOID
##PREC: NONE
#prologue
	sub $sp, $sp, 4
	sw $ra,($sp)
#corps
	la $a0, strRDR			#text d'affichage
	li $v0, 4
	syscall
	
	lw $t0, RDR			#adresse memoire du registre de donnée
	lw $a0, ($t0)
	li $v0, 1
	syscall 			#affichage du RcontrolR
	
	la $a0, lineBreak
	li $v0, 4
	syscall 			#saut a la ligne
#epilogue
	lw $ra, ($sp)
	add $sp, $sp, 4
	
	jr $ra
#->>---------------------------------------------


#->>----------------------------------------------
_sleep_:
##	Met une pause de 500 ms au processeur
##ARGS: VOID
##RETU: VOID
##PREC: NONE

#prologue
	sub $sp, $sp, 8
	sw $a0, ($sp)
	sw $v0, 4($sp)
#corps
	li $a0, 500 			#set time (millisecondes)
	li $v0, 32 			#MARS's sleep function
	syscall
#epilogue
	lw $a0, ($sp)
	lw $v0, 4($sp)
	add $sp, $sp, 8

	jr $ra
#-<<---------------------------------------------


#->>---------------------------------------------
#arret complet du programme
_stop_:
	jal _end_print_
	j _exit_
#-<<---------------------------------------------


#->>---------------------------------------------
#marque la fin d'affichage
_end_print_:
	la $a0, end
	li $v0, 4
	syscall
	li $v0, 0 			#remise a zero de $v0
	jr $ra
#-<<---------------------------------------------


#->>---------------------------------------------
#Sortie du programme
_exit_:
	li $v0, 10
	syscall
#-<<---------------------------------------------
